import { h } from "@stencil/core";
export class StateStepperStepComponent {
    constructor() {
        this.state = '';
    }
    watchHandler(newValue) {
        if (newValue === 'active') {
            this.scrollToMe();
        }
    }
    scrollToMe() {
        setTimeout(() => {
            this.el.scrollIntoView({
                behavior: 'smooth',
                block: 'center',
                inline: 'center'
            });
        });
    }
    componentDidLoad() {
        if (this.state === 'active') {
            this.scrollToMe();
        }
    }
    getStepStateClassName() {
        return this.state;
    }
    render() {
        return (h("div", { class: 'wrapper ' + this.getStepStateClassName() },
            h("div", { class: "icon-wrapper" },
                h("div", { class: "ani-wrapper" },
                    h("div", { class: "icon" },
                        h("slot", { name: "icon" })))),
            h("div", { class: "text" },
                h("slot", { name: "text" }))));
    }
    static get is() { return "state-stepper-step"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() { return {
        "$": ["state-stepper-step.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["state-stepper-step.css"]
    }; }
    static get properties() { return {
        "state": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "state",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
    static get elementRef() { return "el"; }
    static get watchers() { return [{
            "propName": "state",
            "methodName": "watchHandler"
        }]; }
}
